from enum import Enum


class Capability(str, Enum):
    VIEWPROJECTS = "ViewProjects"
    VIEWPROJECTSTATUSES = "ViewProjectStatuses"
    CREATEPROJECTS = "CreateProjects"
    EDITPROJECTS = "EditProjects"
    EDITPROJECTCOMPDEF = "EditProjectCompDef"
    EDITPROJECTWORKFLOW = "EditProjectWorkflow"
    EDITPROJECTMETADATA = "EditProjectMetadata"
    EDITPROJECTNETWORK = "EditProjectNetwork"
    EDITPROJECTACCESS = "EditProjectAccess"
    EDITPROJECTPOLICY = "EditProjectPolicy"
    EDITPROJECTCONFIGURATION = "EditProjectConfiguration"
    REQUESTPROJECTAUTHORIZATION = "RequestProjectAuthorization"
    AUTHORIZEPROJECTS = "AuthorizeProjects"
    ACCESSANYPROJECT = "AccessAnyProject"
    DELETEPROJECTS = "DeleteProjects"
    DELETEANYPROJECT = "DeleteAnyProject"
    SETANYDATASOURCE = "SetAnyDataSource"
    SETDATASOURCES = "SetDataSources"
    RUNPROJECTS = "RunProjects"
    VIEWRESULTS = "ViewResults"
    VIEWANYRESULT = "ViewAnyResult"
    VIEWCOMPUTATIONS = "ViewComputations"
    VIEWANYCOMPUTATION = "ViewAnyComputation"
    DELETECOMPUTATIONS = "DeleteComputations"
    DELETEANYCOMPUTATION = "DeleteAnyComputation"
    MANAGECOMPUTATIONS = "ManageComputations"
    MANAGEANYCOMPUTATION = "ManageAnyComputation"
    RUNCOMPUTATIONS = "RunComputations"
    VIEWPARAMS = "ViewParams"
    MANAGEBOOKMARKS = "ManageBookmarks"
    REQUESTDISTRIBUTEDCOMPUTATIONS = "RequestDistributedComputations"
    SENDCOMPUTATIONMESSAGES = "SendComputationMessages"
    VIEWDATAOBJECTS = "ViewDataObjects"
    VIEWANYDATAOBJECT = "ViewAnyDataObject"
    CREATEDATAOBJECTS = "CreateDataObjects"
    EDITDATAOBJECTS = "EditDataObjects"
    EDITANYDATAOBJECT = "EditAnyDataObject"
    DELETEDATAOBJECTS = "DeleteDataObjects"
    DELETEANYDATAOBJECT = "DeleteAnyDataObject"
    VIEWDATASOURCETYPES = "ViewDataSourceTypes"
    GENERATEMOCKDATA = "GenerateMockData"
    VIEWDATASOURCES = "ViewDataSources"
    VIEWANYDATASOURCE = "ViewAnyDataSource"
    EDITDATASOURCES = "EditDataSources"
    EDITANYDATASOURCE = "EditAnyDataSource"
    CREATEDATASOURCES = "CreateDataSources"
    QUERYDATASOURCES = "QueryDataSources"
    QUERYANYDATASOURCE = "QueryAnyDataSource"
    DELETEDATASOURCES = "DeleteDataSources"
    DELETEANYDATASOURCE = "DeleteAnyDataSource"
    VIEWREMOTESELECTIONS = "ViewRemoteSelections"
    VIEWQUERIES = "ViewQueries"
    CREATESCREENINGSESSIONS = "CreateScreeningSessions"
    VIEWSCREENINGSESSIONS = "ViewScreeningSessions"
    VIEWANYSCREENINGSESSION = "ViewAnyScreeningSession"
    MANAGESCREENINGSESSIONS = "ManageScreeningSessions"
    MANAGEANYSCREENINGSESSION = "ManageAnyScreeningSession"
    VIEWQUERYBOOKMARKS = "ViewQueryBookmarks"
    VIEWANYQUERYBOOKMARK = "ViewAnyQueryBookmark"
    MANAGEQUERYBOOKMARKS = "ManageQueryBookmarks"
    MANAGEANYQUERYBOOKMARK = "ManageAnyQueryBookmark"
    PROMPTLLMS = "PromptLLMs"
    SEARCHONTOLOGIES = "SearchOntologies"
    BUILDCATALOG = "BuildCatalog"
    VIEWTASKPROGRESS = "ViewTaskProgress"
    GETAVAILABILITYSTATUS = "GetAvailabilityStatus"
    VIEWSETTINGS = "ViewSettings"
    EDITSETTINGS = "EditSettings"
    MANAGESTORAGE = "ManageStorage"
    VIEWCONFIG = "ViewConfig"
    DELETESESSIONS = "DeleteSessions"
    MANAGEUSERS = "ManageUsers"
    VIEWUSERINFO = "ViewUserInfo"
    VIEWAUDITLOGS = "ViewAuditLogs"
    VIEWNETWORK = "ViewNetwork"
    SYNCNETWORKS = "SyncNetworks"
    SYNCCONFIG = "SyncConfig"
    GETREMOTEINFOS = "GetRemoteInfos"

    def __str__(self) -> str:
        return str(self.value)
