/* Code generated by cmd/cgo; DO NOT EDIT. */

/* package command-line-arguments */


#line 1 "cgo-builtin-export-prolog"

#include <stddef.h>

#ifndef GO_CGO_EXPORT_PROLOGUE_H
#define GO_CGO_EXPORT_PROLOGUE_H

#ifndef GO_CGO_GOSTRING_TYPEDEF
typedef struct { const char *p; ptrdiff_t n; } _GoString_;
#endif

#endif

/* Start of preamble from import "C" comments.  */




/* End of preamble from import "C" comments.  */


/* Start of boilerplate cgo prologue.  */
#line 1 "cgo-gcc-export-header-prolog"

#ifndef GO_CGO_PROLOGUE_H
#define GO_CGO_PROLOGUE_H

typedef signed char GoInt8;
typedef unsigned char GoUint8;
typedef short GoInt16;
typedef unsigned short GoUint16;
typedef int GoInt32;
typedef unsigned int GoUint32;
typedef long long GoInt64;
typedef unsigned long long GoUint64;
typedef GoInt32 GoInt;
typedef GoUint32 GoUint;
typedef size_t GoUintptr;
typedef float GoFloat32;
typedef double GoFloat64;
#ifdef _MSC_VER
#include <complex.h>
typedef _Fcomplex GoComplex64;
typedef _Dcomplex GoComplex128;
#else
typedef float _Complex GoComplex64;
typedef double _Complex GoComplex128;
#endif

/*
  static assertion to make sure the file is being used on architecture
  at least with matching size of GoInt.
*/
typedef char _check_for_32_bit_pointer_matching_GoInt[sizeof(void*)==32/8 ? 1:-1];

#ifndef GO_CGO_GOSTRING_TYPEDEF
typedef _GoString_ GoString;
#endif
typedef void *GoMap;
typedef void *GoChan;
typedef struct { void *t; void *v; } GoInterface;
typedef struct { void *data; GoInt len; GoInt cap; } GoSlice;

#endif

/* End of boilerplate cgo prologue.  */

#ifdef __cplusplus
extern "C" {
#endif


// GetLastGoError returns the last error generated by the Go code
//
extern __declspec(dllexport) char* GetLastGoError();

// NewPolynomialHEFloatParams creates a new set of hefloat parameters given test params for polynomial evaluation
// and returns them serialized with Marshall Binary and encoded in base64
//
extern __declspec(dllexport) char* NewPolynomialHEFloatParams();

// NewTestPredictionParams creates a new set of HeFloatOperator hefloat given test params for prediction
// and returns them serialized with Marshall Binary and encoded in base64
//
extern __declspec(dllexport) char* NewTestPredictionParams();

// NewHEFloatOperatorFromB64Parameters takes a b64 encoded marshalled hefloat.Parameters to
// instantiate a new hefloat operator.
//
extern __declspec(dllexport) char* NewHEFloatOperatorFromB64Parameters(char* b64params);

// NewHEFloatOperatorFromB64SchemeContext takes a b64 encoded marshalled scheme.Context to
// instantiate a new hefloat operator.
//
extern __declspec(dllexport) char* NewHEFloatOperatorFromB64SchemeContext(char* b64Context);

// GenKeyPair generates a serialized key pair using as first argument the id of the HeFloatOperator
//
extern __declspec(dllexport) char* GenKeyPair(char* id);
extern __declspec(dllexport) char* GetSecretKeyB64(char* id);
extern __declspec(dllexport) char* GetPublicKeyB64(char* id);

// GetRelinearizationKeyBytes returns the bytes of the relinearization key
//
extern __declspec(dllexport) void* GetRelinearizationKeyBytes(char* id);

// EncryptFloatMatrix encrypts a float matrix to a Ciphertable
//
extern __declspec(dllexport) void* EncryptFloatMatrix(char* id, char* plaintext);

// DecryptCipherTable decrypts a ciphertable
//
extern __declspec(dllexport) char* DecryptCipherTable(char* id, void* ciphertext, size_t textSize);

// DecryptPredictionResult decrypts a prediction result using as first argument the id of the cryptosystem
// and bytes of the marshaled encrypted prediction along with its byte size
//
extern __declspec(dllexport) void* DecryptPredictionResult(char* id, void* ciphertext, size_t ctSize);

// EncryptPredictionDataset encrypts a data taking as arguments:
// 1. the id of the cryptosystem,
// 2. the csv bytes
// 3. the csv size
// 4. the predParams as b64 marshaled PredictionParams
// 5. if the header (first line) should be removed as boolean
//
extern __declspec(dllexport) void* EncryptPredictionDataset(char* id, void* csv, size_t csvSize, char* b64PredParams, int removeHeader);

// GenRelinearizationKey generates a relinearization using as first argument the id of the HeFloatOperator
// write a test that calls one of those functions
// pass failing payload: catch error in python
//
extern __declspec(dllexport) char* GenRelinearizationKey(char* id);

// EncodeBase64Url encodes binary data into Base64 URL
//
extern __declspec(dllexport) char* EncodeBase64Url(void* bytes, size_t size);

// DecodeBase64Url decodes binary data from Base64 URL
//
extern __declspec(dllexport) void* DecodeBase64Url(char* base64data);

// DecodeBase64UrlSize decodes binary data from Base64 URL
//
extern __declspec(dllexport) size_t DecodeBase64UrlSize(char* base64data);

// Create an evaluator for subsequent mathematical operations
//
extern __declspec(dllexport) char* GenerateEvaluator(char* id);

// GenerateEncryptor instantiates the encryptor in the hefloat operator.
//
extern __declspec(dllexport) char* GenerateEncryptor(char* id);

// GenerateDecryptor instaniates the decryptor in the hefloat operator.
//
extern __declspec(dllexport) char* GenerateDecryptor(char* id);

// Instantiate the scheme for subsequent mathematical operations
//
extern __declspec(dllexport) char* InstantiateScheme(char* id);

// Encrypt a numeric value
//
extern __declspec(dllexport) void* EncryptNumber(char* id, char* number);

// DecryptNumber decrypts a ciphertable
//
extern __declspec(dllexport) void* DecryptNumber(char* id, void* ciphertext, size_t textSize);

// NewPIRContext creates a new PIR context given the user metadata
//
extern __declspec(dllexport) char* NewPIRContext(char* b64DBparams, char* b64Index);

// GetPIREvaluationKeyBytes returns the bytes of the evaluation key using the PIR context
//
extern __declspec(dllexport) void* GetPIREvaluationKeyBytes(char* id);

// EncryptPIRQuery encrypts a the query search term using as arguments:
// - id of the PIR context as first argument
// - query as a string
//
extern __declspec(dllexport) void* EncryptPIRQuery(char* id, char* query);

// DecryptPIRResult decrypts a PIR result using as arguments:
// - id of the cryptosystems first argument
// - bytes of a marshalled cryptolib.EncryptedPirResult
// returns the bytes of the csv decrypted result
//
extern __declspec(dllexport) void* DecryptPIRResult(char* id, void* resultBytes, size_t resultSize);

// Add adds two encrypted numbers
//
extern __declspec(dllexport) void* Add(char* id, void* number1, void* number2, size_t number1Size, size_t number2Size);

// Multiply multiplies two encrypted numbers
//
extern __declspec(dllexport) void* Multiply(char* id, void* number1, void* number2, size_t number1Size, size_t number2Size);

// PolynomialEvaluation evaluates an encrypted number on a polynomial
//
extern __declspec(dllexport) void* PolynomialEvaluation(char* id, char* polynomialCoefficients, size_t polynomialCoefficientsSize, void* number, size_t numberSize);

#ifdef __cplusplus
}
#endif
