"""
# Diapason utilities

This module provides various utilities for the Diapason SDK.

These utilities are divided in the following submodules:

- `benchmarks`: measure time and memory usage of computations.
- `code`: inspect and send Python code.
- `datagen`: generate mock and synthetic data.
- `io`: read and write input/output flows in bytes.
- `model_performance_eval`: evaluate the performance of machine learning models.
- `plaintext_gwas`: perform GWAS analysis in plaintext.
- `plots`: draw nice figures, and use Tune Insight branding.
- `privacy`: analyse and interpret the output of DP computations.
- `remotedf`: user-friendly interface to preprocessing.
- `time_tools`: measure and display time in nanoseconds.

"""
